Page MenuHome

Sculpt/Vertex/Weight Paint Brush Size Gets Undone After Undoing a Stroke
Closed, ResolvedPublicBUG

Authored By
Seth Quick (SethTooQuick)
Nov 22 2019, 2:59 AM
Tokens
"Heartbreak" token, awarded by mcurt09."Like" token, awarded by Stig."Love" token, awarded by PrettyFireNOI7."Like" token, awarded by Arkhangels."Like" token, awarded by hitrpr."100" token, awarded by bitbutter."Pirate Logo" token, awarded by gilberto_rodrigues."Burninate" token, awarded by UrielAlc."Burninate" token, awarded by mousesanya."The World Burns" token, awarded by Frozen_Death_Knight."Love" token, awarded by rpserge."Burninate" token, awarded by Thane5."Burninate" token, awarded by mindinsomnia."Like" token, awarded by Takain."Like" token, awarded by cultmethod."Like" token, awarded by CyanMajin."Like" token, awarded by Schamph."Like" token, awarded by Leul."Burninate" token, awarded by gobb_blend."Love" token, awarded by MetinSeven.

Description

System Information
Operating system: Win 10
Graphics card: 1060 3gb

Blender Version
Broken: version: 2.83 (sub 0), branch: master, commit date: 2020-01-10 15:03, hash: rB89578a8f6edd

Short description of error
After changing the size, then doing a strike and immediately undoing it, the brush size gets undone as well.

Steps to reproduce

  • Splash Screen > Sculpting or File > New > Sculpting.
  • Change the size of the brush ]
  • Sculpt: Only one stroke.
  • Undo

Related Objects

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes

Just to confirm that problem is still present in 2.83.

Seth Quick (SethTooQuick) renamed this task from 2.81 Sculpt/Vertex/Weight Paint Brush Size Gets Undone After Undoing a Stroke to Sculpt/Vertex/Weight Paint Brush Size Gets Undone After Undoing a Stroke.Jun 13 2020, 11:41 PM

poke. Any news? This problem really pushes away users to make sculpt in Blender. First try and first strokes, and you get annoying bug.

Bug still exists in 2.90. First stroke after brush reset in sculpt mode (not a big deal). Vertex paint and weight paint unfortunately bugged.

283.2 > 290 this bug is annoying it reset all tool setting in sculpt mode

This is impractical it supposed to no modify tools setting...🤕

Just adding another frustrated voice to this issue. Specifically, in Vertex and Weight Paint this issue is really irritating.

This behaviour is the same in Grease Pencil too (undo changes the active tool and the tool settings). imo it'd be more appropriate & convenient if changes to tools (selected tool and tool settings) were not recorded in the undo stack, or optionally ignored while undoing/redoing.

related:
https://developer.blender.org/T77719
https://blender.community/c/rightclickselect/PHfbbc/

Pablo Dobarro (pablodp606) triaged this task as High priority.Aug 6 2020, 2:38 AM

@Campbell Barton (campbellbarton) @Bastien Montagne (mont29) Any clue about what can be causing this to start looking into it? Debugging brushes with this brush is quite hard as you need to set all parameters again to the same values every time you test something and undo. Also, this is causing issues in other areas. For some reason, when this happens the PBVH rebuilds, so all topology info caches and persistent layers are lost.

@Pablo Dobarro (pablodp606) I'd guess this is caused by to initial undo step being a memfile undo step, so reading it is similar to reading the blend file.

However the issue you mention is quite different to the brush size being undone, so it would be good to open a new report for this.

Not only size will be reset, but diferent parameters. Falloff, texture etc.

I am new to this, sorry if I'm posting inappropriately. I just wanted to confirm that I am getting this bug as well on 2.83.5 LTS. It's making sculpting extremely frustrating. I set up a custom brush, do a test sculpt on the mesh, undo, and then all the prams I've set up for that new brush revert back to defaults.

Undo behavior is a nightmare right now in sculpting.

Is this fixed in the latest master and 2.90? I tested this and it seems to be fixed when getting to the "Sculpt Mode" undo step.
The only times I can still reproduce this issue is whit Multires when undoing to a "Multires Apply Base" or "Multires Subdivide" undo step.

Is this fixed in the latest master

Still dead....

Takain (Takain) rescinded a token.
Takain (Takain) awarded a token.

still existing in grease pencil draw mode...

@Bastien Montagne (mont29) Do you know if this is something that can be fixed in a reasonable amount of time? Otherwise maybe we should lower the priority or move it to known issues.

I think this should be a known issue indeed, there is not much to be done here (as in, not fixable without serious design work).

Only proper solution I can see that would be relatively easy to implement would be to decide to treat brush settings as we do with UI data, or the position of the 3D cursor for example, and ignore any of their changes in undo steps. But such a change should be validated as a design decision first.

treat brush settings as we do with UI data, or the position of the 3D cursor for example, and ignore any of their changes in undo steps.

would dearly love that change to happen! (battling against unwanted tool changes every day while using grease pencil)

treat brush settings as we do with UI data, or the position of the 3D cursor for example, and ignore any of their changes in undo steps.

+1

Only proper solution I can see that would be relatively easy to implement would be to decide to treat brush settings as we do with UI data, or the position of the 3D cursor for example, and ignore any of their changes in undo steps. But such a change should be validated as a design decision first.

Yo @Bastien Montagne (mont29) I believe it will be better to seriously consider this option, since unintentionally changing brush settings is so annoying and brush settings should be changed only by the user because a brush is tool like other tool people use, changing the settings is like creating another tool. the butcher will want some knife to cut in certain way and have certain type sharpness. It will be annoying and may be dangerous for him to pick a knife and realize that it is not cutting as he wishes. This undo bug can change so many brush settings without warning the user about the change, this can be a source of many frustrations.

@Bastien Montagne (mont29) I think that if is possible to consider brush settings as UI data that would be an acceptable solution. Should I open another task for this so we can discuss this and move this report to know issue?

I am with the others on this. Make it behave similarly to the UI. In all my years of using any art program, being able to affect your brush settings by using undo/redo has never been a thing. If the user wants to change the brush settings they can do it manually, not through some strange unintuitive system where the settings behave like some form of operator like a regular brush stroke.

Vyacheslav (hitrpr) added a comment.EditedSep 30 2020, 5:38 AM

would dearly love that change to happen! (battling against unwanted tool changes every day while using grease pencil)

+1
At least there should be temporary solution, because this bug spoils workflow A LOT

I am with the others on this. Make it behave similarly to the UI. In all my years of using any art program, being able to affect your brush settings by using undo/redo has never been a thing. If the user wants to change the brush settings they can do it manually, not through some strange unintuitive system where the settings behave like some form of operator like a regular brush stroke.

+1 here as well. This strikes me as the most obvious and user friendly solution.

Only proper solution I can see that would be relatively easy to implement would be to decide to treat brush settings as we do with UI data, or the position of the 3D cursor for example, and ignore any of their changes in undo steps. But such a change should be validated as a design decision first.

Yes please, this is the most annoying bug. Any solution to this is very welcome by the users. You can know by the number of duplicate reports and reactions that this is still a High Priority.

The problem lies more in these things not generating and undo item in the undo history, and so they are grouped together with the next undoable action like the stroke.

If I change brush size and paint a stroke, I think I still would like for it to be undoable in some cases, BUT after two undos, not one.

Vyacheslav (hitrpr) added a comment.EditedOct 1 2020, 2:02 AM

I think I still would like for it to be undoable in some cases

Only when you are tweaking brush and testing it.
BUT! If you will test it witn few strokes, you should do Ctrl+Z few times and it is faster to tweak back manually or reset brush to initial.
Some 2D applications have two options: reset to saved state and reset to «factory settings».

So undoing brush setting is not so much useful.
May be including brush in undo-history should be optional: switch it on, tweak your brushes, switch it off and never care, than Undo will spoil your brush.
I don`t feel this option should be on by default.

+1 This is the worst bug ever :(

Confirmed in 2.90.1. I stumbled on an even worse case. I just used the smudge brush in Image Editor Paint, did about 8-10 strokes, and a single undo switched my brush back to Draw. I've had a couple moments where a single undo in image paint undoes everything I recently did in 3D view, but I'm having difficulty recreating it.

Switching back and forth between 3D and 2D texture painting is pretty wack. I never know what's going to happen. It's making it really difficult to work.

Confirmed in 2.90.1 as well

It's a burning pain in the neck, especially for novices. As a novice in Blender, I do a lot of mistakes and experiments, so I use CTRL+Z (Undo) regularly. So it would be extremely convenient If Undo operation in Blender does not affect tool settings after the first stroke of a brush (for example).

This bug, or unintended behavior, was NOT present in version 2.79. It also worked properly not only in Sculpt but in every other mode such as Vertex Paint and Weight Paint.
Maybe it would be proper to also add to the description that it worked properly in 2.79

This bug persists all across many other tools including texture paint, selections, locking/unlocking (like in vertex groups), in general it doesn't just undo the last step but sometimes several steps related to the tool you are using.

It is so incredibly embarrassing this has not been solved yet, after so many years. This basically makes sculpting in Blender borderline impossible. Undoing any sculpt tool stroke also undoes the last setting which was changed... So it takes just a few random Ctrl-Z presses to completely ruin many minutes of work. Incredible...

Vyacheslav (hitrpr) added a comment.EditedJan 9 2021, 4:04 AM

There is still undo for Dyntopo switch with brush strokes.

upd: fixed

I've just run into this bug whilst trying to customise some brushes. I can't believe this problem has been persisting for years and hasn't been fixed. I don't think I can carry on using Blender with something this annoying hanging over my head when sculpting. Looks like I'm defecting to Z Brush for sculpting. Very disappointed.

I've just run into this bug whilst trying to customise some brushes. I can't believe this problem has been persisting for years and hasn't been fixed. I don't think I can carry on using Blender with something this annoying hanging over my head when sculpting. Looks like I'm defecting to Z Brush for sculpting. Very disappointed.

Yeah sculpting in 2.80+ is overhyped.

I've just run into this bug whilst trying to customise some brushes. I can't believe this problem has been persisting for years and hasn't been fixed. I don't think I can carry on using Blender with something this annoying hanging over my head when sculpting. Looks like I'm defecting to Z Brush for sculpting. Very disappointed.

What would be more helpful is reporting a new bug report because a lot of settings arent changing with an Undo. This is marked as solved because it is supposed to be solved. I am on blender 2.91.2 and the only thing is noticed was that the texture for the brush was reset to standard.

I've just run into this bug whilst trying to customise some brushes. I can't believe this problem has been persisting for years and hasn't been fixed. I don't think I can carry on using Blender with something this annoying hanging over my head when sculpting. Looks like I'm defecting to Z Brush for sculpting. Very disappointed.

Yeah sculpting in 2.80+ is overhyped.

Its certainly underwhelming. As if it wasn't tedious enough building up your own brush sets with all this appending and fake user nonsense!

I've just run into this bug whilst trying to customise some brushes. I can't believe this problem has been persisting for years and hasn't been fixed. I don't think I can carry on using Blender with something this annoying hanging over my head when sculpting. Looks like I'm defecting to Z Brush for sculpting. Very disappointed.

What would be more helpful is reporting a new bug report because a lot of settings arent changing with an Undo. This is marked as solved because it is supposed to be solved. I am on blender 2.91.2 and the only thing is noticed was that the texture for the brush was reset to standard.

I'm on the same version, and almost every brush setting reverts with undo.

Please stop adding random context-less comments in this closed, marked-as-solved report, it is utterly useless.

If you still have issues with undo and brush settings in current master (a.k.a. future 2.93 release currently), create a new report, with full proper required information.